package net.zmobile.ui;

import java.util.Stack;

import javax.microedition.lcdui.Display;

import net.zmobile.ge.ZPoint;
import net.zmobile.ge.ZRect;

public class ZForm extends ZContainer {
	ZFormCanvas canvas = null;

	public static final Stack uiStack = new Stack();
	public static ZForm instance = null;

	public ZForm() {
		instance = this;
		canvas = new ZFormCanvas(instance);
		this.setFullScreen(true);
		this.translateY = ZConstants.TILTE_HEIGHT + 1;
		_w = canvas.getWidth();
		_h = canvas.getHeight();
		uiStack.push(this);
	}

	public void repaint() {
		canvas.repaint();
	}

	private void setFullScreen(boolean value) {
		canvas.setFullScreenMode(value);
		_w = canvas.getWidth();
		_h = canvas.getHeight();

		resize();
		canvas.repaint();
	}

	public void show(Display display) {
		display.setCurrent(canvas);
		setFoucus(true);
		canvas.repaint();
	}

	String _title = "";

	public void setTitle(String title) {
		_title = title;
	}
	public String getTitle() {
		return _title;
	}

	private ZMenu _menu = null;

	public void setMenu(ZMenu menu) {
		_menu = menu;
	}



	public void resize() {
		resizeClientBounds();
		if (_lManger != null) {
			_lManger.resize(new ZRect(_client_x, _client_y, _client_w,
					_client_h), _components);
		}
	}

	protected void resizeClientBounds() {
		_client_x = _x;
		_client_y = _y + ZConstants.TILTE_HEIGHT + 1;

		_client_w = _w;
		_client_h = _h - ZConstants.TILTE_HEIGHT - ZConstants.FOOTER_HEIGHT - 2;
	}

	public void firePointRelease(ZPoint point) {
		if(new ZRect(this._client_x,this._client_y,_client_w,_client_h).contains(point)){
			super.firePointRelease(point);			
		}
	}

	public void firePointPressed(ZPoint point) {
		if(new ZRect(this._client_x,this._client_y,_client_w,_client_h).contains(point)){
		super.firePointPressed(point);
		}
	}
}
