package net.zmobile.ui;

import java.io.IOException;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import net.zmobile.ge.ZPoint;

public class ZRadioButton extends ZComponent {

	public static Image RADIA_BUTTON_OFF = null;
	public static Image RADIA_BUTTON_ON = null;
	static{
		try {
			RADIA_BUTTON_OFF = Image.createImage("/r0.gif");
			RADIA_BUTTON_ON = Image.createImage("/r1.gif");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	boolean isChecked = false;
	public ZRadioButton(String text){
		this._text = text;
		_font = Font.getDefaultFont();
	}
	public void draw(Graphics g) {
		if(_font==null)_font = g.getFont();
		g.setColor(0x0);
		g.drawString(_text, _x + RADIA_BUTTON_OFF.getWidth()+2, _y ,Graphics.TOP | Graphics.LEFT);
	}

	public void drawStatus(Graphics g) {
		if(!isChecked){
			g.drawImage(RADIA_BUTTON_OFF, _x+2, _y+2, Graphics.TOP | Graphics.LEFT);
		}else{
			g.drawImage(RADIA_BUTTON_ON, _x+2, _y+2, Graphics.TOP | Graphics.LEFT);			
		}
		g.setClip(_x, _y, _w, _h);
		if(isFoucus){
			g.setStrokeStyle(Graphics.DOTTED);
			g.drawRect(_x, _y, _w-2, _h-2);
		}
	}
	public void fireSelectedRelease() {
		super.fireSelectedRelease();
		if(isFoucus)isChecked = !isChecked;
	}
	public void firePointRelease(ZPoint point) {
		super.firePointRelease(point);
		if(isFoucus)isChecked = !isChecked;
	}
	public void resetSize() {
		int w = RADIA_BUTTON_OFF.getWidth()+_font.stringWidth(_text)+4;
		int h = RADIA_BUTTON_OFF.getHeight()+4;
		_x = _x + (_w-w)/2-2;
		_y = _y + (_h-h)/2-2;
		_w = w;
		_h = h;
	}
	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x, y, w, h);
		resetSize();
	}

}
